
--require("mobdebug").start() -- only uncomment if using ZeroBrane Studio

application:setFps(60)
application:setBackgroundColor(0x000000)
stage:setOrientation(Stage.LANDSCAPE_LEFT)

math.randomseed(os.time()) for i = 1, 4 do math.random() end

-- create a background image
local texture = Texture.new("images/gui/background.png", false, {wrap = Texture.REPEAT})
local region = TextureRegion.new(texture, 0, 0, application:getContentWidth(), application:getContentHeight())
stage:addChild(Bitmap.new(region))

-- create a new deck of cards and show it on stage
local deck = Deck.new()
stage:addChild(deck)

-- the remainder of the example is GUI elements
-- to perform the various functions of the example

-- reset the deck
stage:addChild(Button.new(Texture.new("images/gui/reset.png"), {
  x = 80,
  y = 288,
  onPressed = function()
    deck:reset()
  end,
}))

-- deal a new card
stage:addChild(Button.new(Texture.new("images/gui/deal.png"), {
  x = 216,
  y = 288,
  onPressed = function()
    deck:dealCard()
  end,
}))

local okay, cancel

-- enter discard selection mode
stage:addChild(Button.new(Texture.new("images/gui/discard.png"), {
  x = 376,
  y = 288,
  onPressed = function()
    local cards = deck:getCards()
    -- only enter discard mode if there is at least one card to discard
    if #cards > 0 then
      deck:unselectAll()
      deck:setMode("discard")
      okay:show(true)
      okay:enable(true)
      cancel:show(true)
      cancel:enable(true)
    end
  end,
}))

-- confirm and perform discard, then re enter normal mode
okay = Button.new(Texture.new("images/gui/okay.png"), {
  x = 160,
  y = 48,
  enabled = false,
  visible = false,
  onPressed = function()
    deck:discard()
    deck:unselectAll()
    deck:setMode("normal")
      okay:show(false)
      okay:enable(false)
      cancel:show(false)
      cancel:enable(false)
  end,
})
stage:addChild(okay)

-- cancel discard and resume normal mode
cancel = Button.new(Texture.new("images/gui/cancel.png"), {
  x = 320,
  y = 48,
  enabled = false,
  visible = false,
  onPressed = function()
    deck:unselectAll()
    deck:setMode("normal")
    okay:setVisible(false)
    cancel:setVisible(false)
    okay.enabled = false
    cancel.enabled = false
  end,
})
stage:addChild(cancel)
